#include "Arrow.h"

#include <QGLWidget>

#include "Cube.h"
#include "Cone.h"

struct ArrowData
{
	Cube shaft;
	Cone head;
	Cone tail;
};

Arrow::Arrow()
{
}

Arrow::~Arrow()
{
}

void Arrow::draw()
{
	createShape();
}

void Arrow::createShape()
{
	enableStates();
	
	// Set the Material properties for the arrow
	GLfloat arrowDiffuse[] = { 0.4f, 0.4f, 0.4f, 1.0f };
	GLfloat headShine[] = { 100.0f };
	
	glEnable(GL_COLOR_MATERIAL);
	
	// Consists of hierarchical transforms
	// Tail
	glPushMatrix();
	glTranslatef(-2.0f, 0.0f, 0.0f);
	glRotatef(90.0, 0.0f, 1.0f, 0.0f);
	glScalef(2.0f, 0.5f, 1.0f);
	glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
	glColor3f(0.4f, 0.4f, 0.4f);
	d->tail.draw();
	glPopMatrix();

	glDisable(GL_COLOR_MATERIAL);
	// Shaft
	glPushMatrix();
	glScalef(5.0f, 0.2f, 1.0f);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, arrowDiffuse);
	d->shaft.draw();
	glPopMatrix();

	// Head
	glPushMatrix();
	glTranslatef(2.0f, 0.0f, 0.0f);
	glRotatef(90.0, 0.0f, 1.0f, 0.0f);
	glScalef(2.0f, 0.7f, 1.0f);
	glMaterialfv(GL_FRONT, GL_SHININESS, headShine);
	d->head.draw();
	glPopMatrix();
	disableStates();
}



