#include "FruitPole2d.h"

#include <QGLWidget>

#include "Quad.h"


struct FruitPole2dData
{
	Quad pole;
	Quad string;
	Quad stringSupport;
	Quad poleSupport;
};

FruitPole2d::FruitPole2d()
{
}

FruitPole2d::~FruitPole2d()
{
}

void FruitPole2d::draw()
{
	createShape();
}

void FruitPole2d::createShape()
{
	// Consists of hierarchical transforms
	// String
	glPushMatrix();
	glTranslatef(0.0f, 0.0f, 0.0f);
	glScalef(0.1f, 5.0f, 1.0f);
	d->string.draw();
	glPopMatrix();

	// String Support
	glPushMatrix();
	glTranslatef(0.0f, 5.0f, 0.0f);
	glScalef(2.0f, 0.5f, 1.0f);
	d->stringSupport.draw();
	glPopMatrix();

	// Pole
	glPushMatrix();
	glTranslatef(2.0f, -9.5f, 0.0f);
	glScalef(1.5f, 15.0f, 1.0f);
	d->pole.draw();
	glPopMatrix();

	// Pole support
	glPushMatrix();
	glTranslatef(0.8f, -9.5f, 0.0f);
	glScalef(4.0f, 1.0f, 1.0f);
	d->poleSupport.draw();
	glPopMatrix();
}