/*
* Quad.h 
* An Interface to create a quad 2d object
* 
* Copyright (c) Brian Gee Chacko, 2010
* M.S.Ramaiah School of Advanced Studies, Bangalore 
*/
#ifndef QUAD_H
#define QUAD_H

#include "Shape.h"

#include <QString>
#include <QVector>
#include <QVector3D>

#include <QtOpenGL>

class Quad : public Shape
{
public:
	Quad();
	~Quad();

	void setTextureFileName(const QString& fileName);
	void draw();

protected:
	void createShape();
	
private:
	GLuint m_texture;
	QString m_fileName;
	QImage m_textureImage;
};

#endif // QUAD_H
