#include "ScoreUI.h"

#include <QVBoxLayout>
#include <QLabel>
#include <QLayout>
#include <QPainter>

ScoreUI::ScoreUI(QWidget* parent)
:QWidget(parent, Qt::FramelessWindowHint | Qt::WindowSystemMenuHint)
{
	m_currScore = 10;
	QFont newFont = font();
	newFont.setBold(true);
	newFont.setPointSize(newFont.pointSize() + 20);
    setFont(newFont);

	m_fileName = ":/Resources/Images/Score_3_1.jpg";
	setMouseTracking(true);
}

ScoreUI::~ScoreUI()
{
}

void ScoreUI::mousePressEvent(QMouseEvent* me)
{
	if(me->button() == Qt::LeftButton)
		m_currScore += 10;
	update();
}

QSize ScoreUI::sizeHint() const
{
    return QSize(240, 200);
}

void ScoreUI::setTopScore(const QString& topScore)
{
	m_topScore = topScore;
	update();
}

void ScoreUI::setFileName(const QString& fileName)
{
	m_fileName = fileName;
	update();
}

void ScoreUI::paintEvent(QPaintEvent* pe)
{
	QPainter painter(this);
	QPixmap pix(m_fileName);
	painter.setRenderHint(QPainter::Antialiasing);
	painter.drawPixmap(0, 0, width(), height(), pix);

	drawScoreUINumberText(&painter);
}

void ScoreUI::drawScoreUINumberText(QPainter* p)
{
/**
 This part of the code block has been left commented on purpose for reference
*/
	//p->save();
 //   p->setWindow(0, 0, 800, 600);
 //   p->setRenderHint(QPainter::Antialiasing);
 //   p->setPen(QPen(Qt::black));
 //   p->setBrush(QBrush(QColor(193, 193, 193, 127)));
 //   p->drawRoundRect(10, 500, 300, 90, 5, 20);

 //   QFont font("ComicSans", 14);
 //   font.setUnderline(true);
 //   p->setFont(font);
 //   p->drawText(100, 520, "Help");

 //   font.setUnderline(false);
 //   font.setPointSize(12);
 //   p->setFont(font);
 //   p->drawText(30, 545,
 //               QString("Left click, hold and drag to blur."));
 //   p->drawText(30, 570,
 //               QString("Scroll wheel to change radius."));
 //   p->restore();

	// The ScoreUI, as in the actual number keeps changing
	p->save();
    p->setWindow(0, 0, 800, 600);
    p->setRenderHint(QPainter::Antialiasing);
	p->setPen(QPen(Qt::yellow));
    p->setBrush(QBrush(QColor(193, 193, 193, 127)));

    QFont font("SansSerif", 60);
    p->setFont(font);
	p->drawText(400, 120, "Top");
	p->drawText(400, 170, "Score");
    p->drawText(300, 250, m_topScore);
    p->restore();

}