#include "Stopwatch.h"

#include <QFile>
#include <QString>
#include <QPainter>
#include <QTextStream>

Stopwatch::Stopwatch(QWidget* parent)
    : QWidget(parent, Qt::FramelessWindowHint | Qt::WindowSystemMenuHint)
{
	m_timeCount = 0;
	
	m_num = new QLCDNumber(this);
	m_num->setNumDigits(8);
	m_time = new QTime;
	m_time->setHMS(0,0,0,0);
	m_timer = new QTimer(this);
	m_timer->start(1000);

	QString text = m_time->toString("hh:mm:ss");
	m_num->display(text);
	m_num->setSegmentStyle(QLCDNumber::Filled);

	m_layout = new QVBoxLayout(this);
	m_layout->addWidget(m_num);

	connect(m_timer, SIGNAL(timeout()), this, SLOT(showTime()));
}
 
Stopwatch::~Stopwatch()
{ 
}

QString Stopwatch::yourScore()
{
	return m_yourScore;
}

QString Stopwatch::topScore()
{
	// Read the last score
	QFile fileRead("../Resources/Docs/Scorecard.txt");
     if (!fileRead.open(QFile::ReadOnly | QIODevice::Text))
         return -1;

	 QByteArray line;
     while (!fileRead.atEnd()) 
	 {
         line = fileRead.readLine();
     }
	 m_topScore = QString(line);
	 fileRead.close();

	return m_topScore;
}

void Stopwatch::updateTopScore()
{
	// Read the last score
	QFile fileRead("../Resources/Docs/Scorecard.txt");
     if (!fileRead.open(QFile::ReadOnly | QIODevice::Text))
         return;

	 QByteArray line;
     while (!fileRead.atEnd()) 
	 {
         line = fileRead.readLine();
     }
	 fileRead.close();

	 QTime oldTime = QTime::fromString(line);
	 int oldTimeSecs = oldTime.second();
	 int currTimeSecs = m_currTime.second();

	 // Do the writing only if yourScore is greater
	 if( currTimeSecs < oldTimeSecs )
	 {
		
		QFile fileWrite("../Resources/Docs/Scorecard.txt");
		if( !fileWrite.open(QFile::WriteOnly | QIODevice::Text) )
			return;

		QTextStream out(&fileWrite);
		m_yourScore = m_currTime.toString("hh:mm:ss");
		out << m_yourScore;
		fileWrite.close();
	 }
}

void Stopwatch::showTime()
{	m_timeCount = m_timeCount+1;
	m_currTime = m_time->addSecs(m_timeCount);
	QString text = m_currTime.toString("hh:mm:ss");
	m_yourScore = text;
	
	m_num->display(text);
}

void Stopwatch::stop()
{
	m_timer->stop();
}

void Stopwatch::mousePressEvent(QMouseEvent* me)
{
	update();
}

QSize Stopwatch::sizeHint() const
{
    return QSize(250, 100);
}

void Stopwatch::paintEvent(QPaintEvent* pe)
{
}